
Redmine - Feature #29473

Submit a form with Ctrl+Enter / Command+Return

2018-09-01 14:29 - Kamil .

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 4.2.0   

Resolution: Fixed   

Description

While editing issue, Ctrl+Enter should invoke "Submit"

While creating new issue Ctrl+Enter should invoke "Create"

Related issues:

Related to Redmine - Feature #449: Keyboard shortcuts Reopened

Has duplicate Redmine - Feature #34912: Save ticket by pressing keyboard key Closed

Precedes Redmine - Feature #33918: Add documentation for #29473 New

Associated revisions

Revision 19986 - 2020-08-28 02:01 - Go MAEDA

Submit a form with Ctrl+Enter / Command+Return (#29473).

Patch by Mizuki ISHIKAWA.

Revision 20255 - 2020-11-05 03:58 - Go MAEDA

"Invalid form authenticity token" error when submitting an Ajax form with Ctrl+Enter (#29473).

Patch by Mizuki ISHIKAWA.

History

#1 - 2018-09-02 02:05 - Go MAEDA

- Related to Feature #449: Keyboard shortcuts added

#2 - 2018-09-12 16:44 - Go MAEDA

- Category set to UI

#3 - 2018-12-13 00:13 - Davide Giacometti

Hi Kamil,

I have added these shortcuts to my Redmine Shortcuts Plugin.

Try it if you want.

Davide

#4 - 2018-12-13 12:27 - Kamil .

Davide,

I've installed 0.2.0 version but it doesn't seem to work.

Both (while creating and editing) it displays browser popup "do you really want to leave this site"?

#5 - 2018-12-13 18:41 - Davide Giacometti

Redmine version?

#6 - 2018-12-13 22:28 - Kamil .

3.4.6.stable
#7 - 2020-06-02 04:34 - Go MAEDA

+1

Many apps or services such as Gitlab, GitHub, Gmail, Outlook, Slack, Facebook, and Twitter support submitting a form by hitting Ctrl+Enter /

⌘+Return. I think that a lot of users are familiar with this shortcut key.

Redmine will be able to provide consistent UI with many other apps if the key combination is supported.

#8 - 2020-07-29 08:37 - Mizuki ISHIKAWA

- File feature-29473.patch added

I have attached a patch.

Add hisSubmitAction variable to not show "do you really want to leave this site?"

Not tested on Windows.

#9 - 2020-08-02 15:32 - Go MAEDA

- Target version set to Candidate for next major release

+1

Nice improvement.

#10 - 2020-08-08 09:28 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

Setting the target version to 4.2.0.

#11 - 2020-08-21 10:10 - Mizuki ISHIKAWA

- File  feature-29473-v2.patch added

I will attach the updated patch.

#12 - 2020-08-26 05:27 - Go MAEDA

The patch can be simplified as follows.

diff --git a/public/javascripts/application.js b/public/javascripts/application.js

index 7076aabcb..825d96c88 100644

--- a/public/javascripts/application.js

+++ b/public/javascripts/application.js

@@ -851,6 +851,14 @@ function setupFilePreviewNavigation() {

   }

 }

+$(document).on('keydown', 'form textarea', function(e) {

+  // Submit the form with Ctrl + Enter or Command + Return

+  var targetForm = $(e.target).closest('form');

+  if(e.keyCode == 13 && ((e.ctrlKey && !e.metaKey) || (!e.ctrlKey && e.metaKey) && targetForm.length)) {

+    $(e.target).closest('form').find('textarea').blur().removeData('changed');

+    targetForm.submit();

+  }

+});

 function hideOnLoad() {

It is not necessary to process keydown events for input[type="text"] because it submits the form by pressing Enter/Return by default. The form is

submitted also by Ctrl+Enter/Option+Return

If the keydown for input is removed, submit() can always be used. we don't have to use both click() and submit() as

attachment:feature-29473-v2.patch do. Modal dialogs to add a category or a target version also works as expected

#13 - 2020-08-26 06:14 - Mizuki ISHIKAWA

Go MAEDA wrote:

The patch can be simplified as follows.

[...]

2025-05-01 2/3



It is not necessary to process keydown events for input[type="text"] because it submits the form by pressing Enter/Return by default. The

form is submitted also by Ctrl+Enter/Option+Return

If the keydown for input is removed, submit() can always be used. we don't have to use both click() and submit() as

attachment:feature-29473-v2.patch do. Modal dialogs to add a category or a target version also works as expected

 That looks good.

#14 - 2020-08-28 02:01 - Go MAEDA

- Subject changed from Handle Ctrl+Enter while editing issue to Submit a form with Ctrl+Enter / Command+Return

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for improving Redmine.

#15 - 2020-08-28 05:37 - Mischa The Evil

- Precedes Feature #33918: Add documentation for #29473 added

#16 - 2020-10-14 09:18 - Mizuki ISHIKAWA

- File support-ajax-form.patch added

For Ajax form, using this shortcut key will result in an "Invalid form authenticity token" Error.

Example: When edit an existing journal note.

I wrote a patch to solve that problem.

#17 - 2020-11-05 03:58 - Go MAEDA

Mizuki ISHIKAWA wrote:

For Ajax form, using this shortcut key will result in an "Invalid form authenticity token" Error.

Example: When edit an existing journal note.

I wrote a patch to solve that problem.

 Committed the fix. Thank you.

#18 - 2021-03-18 00:33 - Go MAEDA

- Has duplicate Feature #34912: Save ticket by pressing keyboard key added

Files

feature-29473.patch 1.18 KB 2020-07-29 Mizuki ISHIKAWA

 feature-29473-v2.patch 1.03 KB 2020-08-21 Mizuki ISHIKAWA

support-ajax-form.patch 1.06 KB 2020-10-14 Mizuki ISHIKAWA
